lap.tel.com/Models/RepairStatus.cs
using System.ComponentModel.DataAnnotations;
using lap.tel.com.Models;

namespace lap.tel.com_project.Models
{
    public enum RepairStatusEnum
    {
        [Display(Name = "Nowe zgłoszenie")]
        NewRequest,

        [Display(Name = "Otrzymano przesyłkę")]
        PackageReceived,

        [Display(Name = "W trakcie diagnozy")]
        DiagnosticsInProgress,

        [Display(Name = "W trakcie naprawy")]
        RepairInProgress,

        [Display(Name = "Odesłano przesyłkę")]
        PackageSent,

        [Display(Name = "Naprawa zakończona")]
        RepairCompleted
    }
    public class RepairStatus
    {
        public int RepairStatusId { get; set; }

        [Display(Name = "Numer zgłoszenia"), Required]
        public int DeviceId { get; set; }

        [Display(Name = "Numer zgłoszenia")]
        public virtual Device? Device { get; set; }

        [Display(Name = "Wybierz typ naprawy"), Required]
        public int RepairTypeId { get; set; }

        [Display(Name = "Typ naprawy")]
        public virtual RepairType? RepairType { get; set; }

        [Display(Name = "Status naprawy"), Required]
        public RepairStatusEnum Status { get; set; }

        [Display(Name = "Data zgłoszenia"), Required]
        public DateTime DateSubmitted { get; set; }

        [Display(Name = "Data zakończenia")]
        public DateTime? DateCompleted { get; set; }
        public bool IsArchived { get; set; }

        public string? UserId { get; set; }
        public virtual AppUser? User { get; set; }
    }
}

lap.tel.com/Controllers/RepairStatusController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using lap.tel.com.Data;
using lap.tel.com_project.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using lap.tel.com.Models;

namespace lap.tel.com.Controllers
{
    [Authorize]
    public class RepairStatusController : Controller
    {
        private readonly laptelcomContext _context;
        private readonly UserManager<AppUser> _userManager;
        private readonly ILogger<RepairStatusController> _logger;

        public RepairStatusController(laptelcomContext context, UserManager<AppUser> userManager, ILogger<RepairStatusController> logger)
        {
            _context = context;
            _userManager = userManager;
            _logger = logger;
        }

        // GET: RepairStatus
        public async Task<IActionResult> Index()
        {
            var userId = _userManager.GetUserId(User);
            var repairStatuses = _userManager.IsInRoleAsync(await _userManager.GetUserAsync(User), "Administrator").Result
                ? _context.RepairStatus.Include(r => r.Device).Include(r => r.RepairType)
                : _context.RepairStatus.Include(r => r.Device).Include(r => r.RepairType).Where(r => r.UserId == userId);

            return View(await repairStatuses.ToListAsync());
        }

        // GET: RepairStatus/Create
        [Authorize(Roles = "Administrator")]
        public IActionResult Create()
        {
            ViewData["DeviceId"] = new SelectList(_context.Device, "DeviceId", "Marka");
            ViewData["RepairTypeId"] = new SelectList(_context.RepairType, "RepairTypeId", "RepairName");
            return View();
        }

        // POST: RepairStatus/Create
        // To protect from overposting attacks, enable the specific properties you want to bind to.
        // For more details, see http://go.microsoft.com/fwlink/?LinkId=317598.
        // POST: RepairStatus/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Administrator")]
        public async Task<IActionResult> Create([Bind("RepairStatusId,DeviceId,RepairTypeId,Status,DateSubmitted,DateCompleted,UserId")] RepairStatus repairStatus)
        {
            if (ModelState.IsValid)
            {
                _context.Add(repairStatus);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            ViewData["DeviceId"] = new SelectList(_context.Device, "DeviceId", "Marka", repairStatus.DeviceId);
            ViewData["RepairTypeId"] = new SelectList(_context.RepairType.Where(rt => !rt.IsDeleted), "RepairTypeId", "RepairName", repairStatus.RepairTypeId);
            return View(repairStatus);
        }


        // GET: RepairStatus/Edit/5
        [Authorize(Roles = "Administrator")]
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null || _context.RepairStatus == null)
            {
                _logger.LogError("Edit: ID is null or _context.RepairStatus is null");
                return NotFound();
            }

            var repairStatus = await _context.RepairStatus.FindAsync(id);
            if (repairStatus == null)
            {
                _logger.LogError("Edit: RepairStatus not found for ID {Id}", id);
                return NotFound();
            }

            var viewModel = new RepairStatusEditViewModel
            {
                RepairStatusId = repairStatus.RepairStatusId,
                DeviceId = repairStatus.DeviceId,
                Status = repairStatus.Status,
                UserId = repairStatus.UserId,
                DateSubmitted = repairStatus.DateSubmitted
            };

            return View(viewModel);
        }

        // POST: RepairStatus/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Administrator")]
        public async Task<IActionResult> Edit(RepairStatusEditViewModel viewModel)
        {
            if (!ModelState.IsValid)
            {
                return View(viewModel);
            }

            var repairStatus = await _context.RepairStatus.FindAsync(viewModel.RepairStatusId);
            if (repairStatus == null)
            {
                _logger.LogError("Edit POST: RepairStatus not found for ID {Id}", viewModel.RepairStatusId);
                return NotFound();
            }

            repairStatus.Status = viewModel.Status;
            if (viewModel.Status == RepairStatusEnum.RepairCompleted)
            {
                repairStatus.DateCompleted = DateTime.Now;
                repairStatus.IsArchived = true;
            }

            try
            {
                _context.Update(repairStatus);
                await _context.SaveChangesAsync();
                _logger.LogInformation("Edit POST: Successfully updated RepairStatus with ID {Id}", viewModel.RepairStatusId);
            }
            catch (DbUpdateConcurrencyException ex)
            {
                _logger.LogError("Edit POST: Concurrency error: {Message}", ex.Message);
                throw;
            }

            return RedirectToAction("RepairStatus", "Admin");
        }

        private bool RepairStatusExists(int id)
        {
            return (_context.RepairStatus?.Any(e => e.RepairStatusId == id)).GetValueOrDefault();
        }

        // GET: RepairStatus/Delete/5
        [Authorize(Roles = "Administrator")]
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null || _context.RepairStatus == null)
            {
                return NotFound();
            }

            var repairStatus = await _context.RepairStatus
                .Include(r => r.Device)
                .Include(r => r.RepairType)
                .FirstOrDefaultAsync(m => m.DeviceId == id);
            if (repairStatus == null)
            {
                return NotFound();
            }

            return View(repairStatus);
        }

        // POST: RepairStatus/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        [Authorize(Roles = "Administrator")]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var repairStatus = await _context.RepairStatus.Include(rs => rs.Device).FirstOrDefaultAsync(rs => rs.DeviceId == id);
            if (repairStatus != null)
            {
                // Usuń Device przed usunięciem RepairStatus
                if (repairStatus.Device != null)
                {
                    _context.Device.Remove(repairStatus.Device);
                }
                _context.RepairStatus.Remove(repairStatus);
                await _context.SaveChangesAsync();
            }
            return RedirectToAction("RepairStatus", "Admin");
        }

        public IActionResult RepairSubmitted(int id)
        {
            {
                var repairStatus = _context.RepairStatus.Find(id);
                if (repairStatus == null)
                {
                    return NotFound();
                }

                return View(repairStatus);
            }
        }
    }
}

lap.tel.com/Controllers/RepairTypesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using lap.tel.com.Data;
using lap.tel.com_project.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using lap.tel.com.Models;

namespace lap.tel.com.Controllers
{
    [Authorize(Roles = "Administrator")]
    public class RepairTypesController : Controller
    {
        private readonly laptelcomContext _context;
        private readonly UserManager<AppUser> _userManager;

        public RepairTypesController(laptelcomContext context, UserManager<AppUser> userManager)
        {
            _context = context;
            _userManager = userManager;
        }

        // GET: RepairTypes
        public async Task<IActionResult> Index()
        {
            // Filtrowanie usuniętych typów napraw
            var repairTypes = await _context.RepairType
                .Where(rt => !rt.IsDeleted)
                .ToListAsync();
            return View(repairTypes);
        }

        // GET: RepairTypes/Create
        public IActionResult Create()
        {
            return View();
        }

        // POST: RepairTypes/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("RepairTypeId,RepairName,RepairCost,RepairDescription,UserId")] RepairType repairType)
        {
            if (ModelState.IsValid)
            {
                _context.Add(repairType);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            return View(repairType);
        }

        // GET: RepairTypes/Edit/5
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var repairType = await _context.RepairType.FindAsync(id);
            if (repairType == null)
            {
                return NotFound();
            }
            return View(repairType);
        }

        // POST: RepairTypes/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, [Bind("RepairTypeId,RepairName,RepairCost,RepairDescription,UserId,IsDeleted")] RepairType repairType)
        {
            if (id != repairType.RepairTypeId)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    _context.Update(repairType);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!RepairTypeExists(repairType.RepairTypeId))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            return View(repairType);
        }

        // GET: RepairTypes/Delete/5
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var repairType = await _context.RepairType
                .FirstOrDefaultAsync(m => m.RepairTypeId == id);
            if (repairType == null)
            {
                return NotFound();
            }

            return View(repairType);
        }

        // POST: RepairTypes/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var repairType = await _context.RepairType.FindAsync(id);
            if (repairType != null)
            {
                if (repairType.RepairName == "Inne")
                {
                    // Możesz dodać komunikat dla użytkownika informujący, że tego typu nie można usunąć
                    TempData["Error"] = "Typ naprawy 'Inne' nie może być usunięty.";
                    return RedirectToAction(nameof(Index));
                }
                repairType.IsDeleted = true;  // Oznacz jako usunięty
                _context.Update(repairType);
            }

            await _context.SaveChangesAsync();
            return RedirectToAction(nameof(Index));
        }

        private bool RepairTypeExists(int id)
        {
            return _context.RepairType.Any(e => e.RepairTypeId == id);
        }
    }
}

lap.tel.com/Views/Admin/Dashboard.cshtml
@{
    ViewData["Title"] = "Admin Dashboard";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<h1>Panel Administratora</h1>
<p>Zarządzanie systemem</p>

<div class="container">
    <div class="row">
        <div class="col-md-3 col-sm-6">
            <a class="admin-tile" asp-area="" asp-controller="RepairTypes" asp-action="Index">
                <div class="tile-content">
                    <span>Typy napraw</span>
                </div>
            </a>
        </div>
        <div class="col-md-3 col-sm-6">
            <a class="admin-tile" asp-area="" asp-controller="Admin" asp-action="RepairStatus">
                <div class="tile-content">
                    <span>Lista napraw</span>
                </div>
            </a>
        </div>
        <div class="col-md-3 col-sm-6">
            <a class="admin-tile" asp-area="" asp-controller="Admin" asp-action="UserList">
                <div class="tile-content">
                    <span>Użytkownicy</span>
                </div>
            </a>
        </div>
        <div class="col-md-3 col-sm-6">
            <a asp-controller="Devices" asp-action="Create" class="admin-tile">
                <div class="tile-content">
                    <span>Dodaj naprawę</span>
                </div>
            </a>
        </div>
        <div class="col-md-3 col-sm-6">
            <a class="admin-tile" asp-area="" asp-controller="Admin" asp-action="RepairArchiwe">
                <div class="tile-content">
                    <span>Archiwum napraw</span>
                </div>
            </a>
        </div>
    </div>
</div>

lap.tel.com/Views/Admin/RepairArchiwe.cshtml
@model IEnumerable<lap.tel.com_project.Models.RepairStatus>

@{
    ViewData["Title"] = "Archiwum napraw";
}

<h2>Archiwum napraw</h2>

<p>
    <a class="btn btn-dark" asp-controller="Admin" asp-action="Dashboard">Powrót</a>
</p>

<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Device)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.User.NumerTel)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.RepairType)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Status)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.DateSubmitted)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.DateCompleted)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Device.DeviceId)
                </td>
                <td>
                    @if (item.User != null)
                    {
                        <a class="btn btn-outline-secondary btn-sm" asp-action="UserDetails" asp-route-id="@item.User.Id">@Html.DisplayFor(modelItem => item.User.NumerTel)</a>
                    }
                    else
                    {
                        <span>Brak użytkownika</span>
                    }
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.RepairType.RepairName)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Status)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.DateSubmitted)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.DateCompleted)
                </td>
                <td>
                    <a class="btn btn-light btn-sm" asp-controller="Devices" asp-action="Details" asp-route-id="@item.Device.DeviceId">Szczegóły</a>
                    <a class="btn btn-danger btn-sm" asp-controller="RepairStatus" asp-action="Delete" asp-route-id="@item.Device.DeviceId">Usuń</a>
                </td>
            </tr>
        }
    </tbody>
</table>

lap.tel.com/Views/Admin/RepairStatus.cshtml
@model IEnumerable<lap.tel.com_project.Models.RepairStatus>

@{
    ViewData["Title"] = "Lista napraw";
}

<h2>Lista napraw</h2>

<p>
    <a class="btn btn-dark" asp-controller="Admin" asp-action="Dashboard">Powrót</a>
</p>

<table class="table">
    <thead>
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.Device)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.User.NumerTel)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.RepairType)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.Status)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.DateSubmitted)
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Device.DeviceId)
                </td>
                <td>
                    @if (item.User != null)
                    {
                        <a class="btn btn-outline-secondary btn-sm" asp-action="UserDetails" asp-route-id="@item.User.Id">@Html.DisplayFor(modelItem => item.User.NumerTel)</a>
                    }
                    else
                    {
                      <span>Brak użytkownika</span>
                    }
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.RepairType.RepairName)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Status)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.DateSubmitted)
                </td>
                <td>
                    <a class ="btn btn-light btn-sm" asp-controller="Devices" asp-action="Details" asp-route-id="@item.Device.DeviceId">Szczegóły</a>
                    <a class="btn btn-primary btn-sm" asp-controller="RepairStatus" asp-action="Edit" asp-route-id="@item.Device.DeviceId">Edycja</a>
                    <a class="btn btn-danger btn-sm"  asp-controller="RepairStatus" asp-action="Delete" asp-route-id="@item.Device.DeviceId">Usuń</a>
                </td>
            </tr>
        }
    </tbody>
</table>

lap.tel.com/Views/Admin/UserDelete.cshtml
@model lap.tel.com.Models.AppUser
@{
    ViewData["Title"] = "Usuń użytkownika";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Usuń użytkownika</h2>

<h5>Czy na pewno chcesz usunąć tego użytkownika?</h5>
<div>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            Email
        </dt>
        <dd class="col-sm-10">
            @Model.Email
        </dd>
        <dt class="col-sm-2">
            Imię
        </dt>
        <dd class="col-sm-10">
            @Model.Imie
        </dd>
        <dt class="col-sm-2">
            Nazwisko
        </dt>
        <dd class="col-sm-10">
            @Model.Nazwisko
        </dd>
    </dl>

    <form asp-action="UserDelete">
        <input type="hidden" asp-for="Id" />
        <a class="btn btn-dark" asp-action="UserList" class="btn btn-secondary">Powrót</a>
        <input class="btn btn-danger" type="submit" value="Usuń" class="btn btn-danger" />
    </form>
</div>

lap.tel.com/Views/Admin/UserDetails.cshtml
@model lap.tel.com.Models.AppUser
@{
    ViewData["Title"] = "Szczegóły uzytkownika";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Szczegóły użytkownika</h2>

<div>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            Email
        </dt>
        <dd class="col-sm-10">
            @Model.Email
        </dd>
        <dt class="col-sm-2">
            Imię
        </dt>
        <dd class="col-sm-10">
            @Model.Imie
        </dd>
        <dt class="col-sm-2">
            Nazwisko
        </dt>
        <dd class="col-sm-10">
            @Model.Nazwisko 
        </dd>
        <dt class="col-sm-2">
            Numer telefonu
        </dt>
        <dd class="col-sm-10">
            @Model.NumerTel
        </dd>
        <dt class="col-sm-2">
            Adres
        </dt>
        <dd class="col-sm-10">
            @Model.Adres
        </dd>
        <dt class="col-sm-2">
            Kod Pocztowy
        </dt>
        <dd class="col-sm-10">
            @Model.KodPocztowy 
        </dd>
        <dt class="col-sm-2">
            Miejscowość
        </dt>
        <dd class="col-sm-10">
            @Model.Miejscowosc
        </dd>
        <dt class="col-sm-2">
            Data Urodzenia
        </dt>
        <dd class="col-sm-10">
            @Model.DataUrodzenia.ToShortDateString()
        </dd>
    </dl>
    <a class="btn btn-dark" onclick="window.history.back();">Powrót</a>
</div>

lap.tel.com/Views/Admin/UserList.cshtml
@model IEnumerable<lap.tel.com.Models.AppUser>
@{
    ViewData["Title"] = "Lista użytkowników";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h2>Lista uzytkowników</h2>

<p>
    <a class="btn btn-dark" asp-controller="Admin" asp-action="Dashboard">Powrót</a>
</p>

<table class="table">
    <thead>
        <tr>
            <th>ID</th>
            <th>Email</th>
            <th>Imię</th>
            <th>Nazwisko</th>
            <th>Numer Telefonu</th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var user in Model)
        {
            <tr>
                <td>@user.Id</td>
                <td>@user.Email</td>
                <td>@user.Imie</td>
                <td>@user.Nazwisko</td>
                <td>@user.NumerTel</td>
                <td>
                    <a class="btn btn-light btn-sm" asp-action="UserDetails" asp-route-id="@user.Id" class="btn btn-info">Szczegóły</a>
                    <a class="btn btn-danger btn-sm" asp-action="UserDelete" asp-route-id="@user.Id" class="btn btn-danger">Usuń</a>
                </td>
            </tr>
        }
    </tbody>
</table>